org.deidentifier.arx.aggregates

## Class StatisticsQuality

- java.lang.Object
- - org.deidentifier.arx.aggregates.StatisticsQuality

    public class StatisticsQuality
    extends java.lang.Object

Encapsulates statistics obtained using various quality models

Author:
  Fabian Prasser

### Method Summary

All Methods Instance Methods Concrete Methods
`QualityMeasureRowOriented` `getAmbiguity()` Quality according to the "Ambiguity" model proposed in: Goldberger, Tassa: "Efficient Anonymizations with Enhanced Utility" Trans Data Priv
`QualityMeasureColumnOriented` `getAttributeLevelSquaredError()` Attribute-level squared error
`java.util.List<java.lang.String>` `getAttributes()` Returns a list of all attributes considered
`QualityMeasureRowOriented` `getAverageClassSize()` Quality according to the "AECS" model proposed in: K.
`DataType<?>` `getDataType(java.lang.String attribute)` Returns the data type for the attribute
`QualityMeasureRowOriented` `getDiscernibility()` Quality according to the "Discernibility" model proposed in: R.
`QualityMeasureColumnOriented` `getGeneralizationIntensity()` Quality according to the "Precision" model proposed in: L.
`QualityMeasureColumnOriented` `getGranularity()` Quality according to the "Loss" model proposed in: Iyengar, V.: "Transforming data to satisfy privacy constraints" Proc Int Conf Knowl Disc Data Mining, p. 279-288 (2002)
`QualityMeasureColumnOriented` `getMissings()` Returns the fraction of missing values of the attributes considered
`QualityMeasureColumnOriented` `getNonUniformEntropy()` Quality according to the "Non-Uniform Entropy" model proposed in: A.
`QualityMeasureRowOriented` `getRecordLevelSquaredError()` Quality according to the model proposed in: D.
`QualityMeasureRowOriented` `getSSESST()` Quality according to the model proposed in: Solanas, Agusti, Antoni Martinez-Balleste, and J.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### getAmbiguity

    public QualityMeasureRowOriented getAmbiguity()

Quality according to the "Ambiguity" model proposed in:
Goldberger, Tassa: "Efficient Anonymizations with Enhanced Utility" Trans Data Priv

Returns:
  Quality measure

#### getAttributeLevelSquaredError

    public QualityMeasureColumnOriented getAttributeLevelSquaredError()

Attribute-level squared error

Returns:
  Quality measure

#### getAttributes

    public java.util.List<java.lang.String> getAttributes()

Returns a list of all attributes considered

Returns:
  the attributes

#### getAverageClassSize

    public QualityMeasureRowOriented getAverageClassSize()

Quality according to the "AECS" model proposed in:
K. LeFevre, D. DeWitt, R. Ramakrishnan: "Mondrian multidimensional k-anonymity" Proc Int Conf Data Engineering, 2006.

Returns:
  Quality measure

#### getDataType

    public DataType<?> getDataType(java.lang.String attribute)

Returns the data type for the attribute

Parameters:
  `attribute` -
Returns:

#### getDiscernibility

    public QualityMeasureRowOriented getDiscernibility()

Quality according to the "Discernibility" model proposed in:
R. Bayardo, R. Agrawal: "Data privacy through optimal k-anonymization" Proc Int Conf Data Engineering, 2005, pp. 217-228

Returns:
  Quality measure

#### getGeneralizationIntensity

    public QualityMeasureColumnOriented getGeneralizationIntensity()

Quality according to the "Precision" model proposed in:
L. Sweeney: "Achieving k-anonymity privacy protection using generalization and suppression" J Uncertain Fuzz Knowl Sys 10 (5) (2002) 571-588.

Returns:
  Quality measure

#### getGranularity

    public QualityMeasureColumnOriented getGranularity()

Quality according to the "Loss" model proposed in:
Iyengar, V.: "Transforming data to satisfy privacy constraints" Proc Int Conf Knowl Disc Data Mining, p. 279-288 (2002)

Returns:
  Quality measure

#### getMissings

    public QualityMeasureColumnOriented getMissings()

Returns the fraction of missing values of the attributes considered

Returns:
  the datatypes

#### getNonUniformEntropy

    public QualityMeasureColumnOriented getNonUniformEntropy()

Quality according to the "Non-Uniform Entropy" model proposed in:
A. De Waal and L. Willenborg: "Information loss through global recoding and local suppression" Netherlands Off Stat, vol. 14, pp. 17-20, 1999.

Returns:
  Quality measure

#### getRecordLevelSquaredError

    public QualityMeasureRowOriented getRecordLevelSquaredError()

Quality according to the model proposed in:
D. Sanchez, S. Martinez, and J. Domingo-Ferrer. Comment on unique in the shopping mall: On the reidentifiability of credit card metadata. Science, 351(6279):1274-1274, 2016.

Returns:
  Quality measure

#### getSSESST

    public QualityMeasureRowOriented getSSESST()

Quality according to the model proposed in:
Solanas, Agusti, Antoni Martinez-Balleste, and J. Domingo-Ferrer. V-MDAV: a multivariate microaggregation with variable group size. 17th COMPSTAT Symposium of the IASC, Rome. 2006.

Returns:
  Quality measure